// Copyright (c) 2002-2007 Telelogic AB
// All rights reserved.

/*
<trigger>
	<usage>bsf clear_attribute_value attributes</usage>
	<version>5.0</version>
	<description>
		清除所有指定属性中的值</description>
	<argument1>
		<name>attributes</name>
		<required>yes</required>
		<type>string</type>
		<description>要清除的一个或多个以空格分隔的属性。</description>
	</argument1>
</trigger>
*/
importPackage(Packages.com.telelogic.cs.api);

var args = bsf.lookupBean('args');
var event = bsf.lookupBean('event');
var change = bsf.lookupBean('api');
var log = bsf.lookupBean('log');

var options = OptionParser.parse(args);

if (options.args.length < 1)
{
	log.error('Could not clear attribute values: no attributes were given.');
	log.error('Usage: clear_attribute_value.js attribute_name [attribute_name...]');
	log.error('Example: clear_attribute_value.js reviewer_1_approved');
}
else
{
	try
	{
		change.deleteAttributes(event.adminUser.token, event.objectId, options.args);
	}
	catch (error)
	{
		event.fail(error.message || error.toString());
	}
}
