<!-- forms\admin_framework\manage_roles.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<html>
<head>
	<style type="text/css">
@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/dijit.css";
@import "<change:urlCreator webResource='JS'/>dojo/dijit/themes/tundra/tundra.css";

<change:wsletExpander>
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=styles/default.css -->
<!-- /WSLET -->
	
<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=styles/visual_table.css -->
<!-- PARAM NAME=styles/acl_editor.css -->
<!-- /WSLET -->
</change:wsletExpander>

div.membersList
{
	width: 90%;
	padding: 2px;
	border: 1px solid gray;
	float: left;
	cursor: pointer;
	margin-right: 1em;
	min-height: 14px;
	background-color: white;
}

	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='BASEURL'/>/dwr/interface/ManageRolesAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	
	<script type="text/javascript">
dojo.require("dijit.Dialog");
dojo.require("dijit.form.CheckBox");

<change:wsletExpander>

<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=StyleUtils.js -->
<!-- /WSLET -->

<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=EventUtils.js -->
<!-- /WSLET -->

<!-- WSLET CODE=PTInclude -->
<!-- PARAM NAME=Zebra.js -->
<!-- PARAM NAME=TableSorter.js -->
<!-- PARAM NAME=domUtilities.js -->
<!-- PARAM NAME=Layout.js -->
<!-- PARAM NAME=Shim.js -->
<!-- PARAM NAME=MessageFormat.js -->
<!-- PARAM NAME=SelectUtils.js -->
<!-- PARAM NAME=ScrapeText.js -->
<!-- /WSLET -->
</change:wsletExpander>


<change:privilegeInfo property="LIFECYCLE_AND_SPECIAL_PRIVILEGES" var="privilegesToLifecycleMap"/>

function Roles(){}

/* Methods and variables for filtering and gathering the data */
Roles.ONE_ROLE = '<change:resource key="rolesShowingOneRole"/>';
Roles.X_OF_X_ROLES = '<change:resource key="rolesShowingXofX"/>';
Roles.X_ROLES = '<change:resource key="rolesShowingXRoles"/>';

Roles.columnValueFunctions = [
	function(row)
	{
		return ScrapeText.fromInputs(row.cells[0]);
	},

	function(row)
	{
		return ScrapeText.fromTextNodes(row.cells[1]);
	}];

Roles.updateVisibleRoleCountMessage = function(tbody)
{	
	var total = 0;
	var visible = 0;
	
	for (var i = 0; i < tbody.rows.length; i++)
	{
		var row = tbody.rows[i];

		if (row.style.display != 'none')
		{
			++visible;
		}

		++total;
	}
	
	Roles._setVisibleRoleCountMessage(visible, total);
};

Roles._setVisibleRoleCountMessage = function(current, total)
{
	var messageNode = dojo.byId('count-message');
	var child = getChildTextNodeByIndex(messageNode, 0);
	
	var allRolesMessage = (total == 1)
		? Roles.ONE_ROLE
		: Roles.X_ROLES;
		
	var message = (current == total)
		? new MessageFormat(allRolesMessage).format([total])
		: new MessageFormat(Roles.X_OF_X_ROLES).format([current, total]);

	messageNode.innerHTML = message;
};

Roles.filterMatchesRow = function(filter, row, columnValueFunctions)
{
	var cells = row.cells;
	
	for (var i = 0; i < columnValueFunctions.length; i++)
	{
		var cellValue = columnValueFunctions[i](row).toLowerCase();

		if (null == cellValue) continue;

		if (-1 != cellValue.indexOf(filter))
		{
			return true;
		}
	}

	return false;
};

Roles.filterKeyUp = function(evt)
{
	if (evt.keyCode == 13)
	{
		Roles.filter_onClick();
	}
};

Roles.filter_onClick = function()
{
	var rows = dojo.byId('user-roles').rows;
	var filterText = dojo.byId('filter-string');
	var filterString = filterText.value.toLowerCase();

	for (var i = 0; i < rows.length; i++)
	{
		if (Roles.filterMatchesRow(filterString, rows[i], Roles.columnValueFunctions))
		{
			rows[i].style.display = '';
		}
		else
		{
			rows[i].style.display = 'none';
		}
	}

	Roles.syncPageWithFilteredResults();
	dojo.byId("filter-all-button").disabled = false;
	filterText.select();
	filterText.focus();
};

Roles.showAll_onClick = function()
{
	dojo.byId('filter-string').value = '';

	var table = dojo.byId('role-table');
	var rows = table.getElementsByTagName('tr');
	for (var i = 0; i < rows.length; i++)
	{
		var row = rows[i];
		row.style.display = '';
	}
	
	dojo.byId("filter-all-button").disabled = true;
	Roles.syncPageWithFilteredResults();
};

Roles.syncPageWithFilteredResults = function()
{
	var foldersTbody = dojo.byId('user-roles');
	Zebra.stripeBody(foldersTbody, 'odd-row');
	Roles.updateVisibleRoleCountMessage(foldersTbody);
};

/* Methods for creating new table rows */
Roles._getUniqueId = function()
{
	if ( typeof this.counter == 'undefined' )
	{
		this.counter = 0;
	}
		
	return new Date().getTime() + "_" + this.counter++;
};

Roles._buildNewRow = function()
{
	var row = document.createElement('tr');
	var rowId = Roles._getUniqueId();
	
	row.setAttribute('rowId', rowId);
	
	var nameTD = document.createElement('td');
	var nameInput = document.createElement('input');
	nameInput.size = 30;
	nameInput.id = 'name' + rowId;
	nameInput.rowId = rowId;
	nameInput.originalValue = "";
	nameInput.onblur = Roles.roleNameChanged;
	nameTD.appendChild(nameInput);
	row.appendChild(nameTD);
	
	var membersTD = document.createElement('td');
	var membersContainerDiv = document.createElement('div');
	var membersDiv = document.createElement('div');
	membersDiv.id = "members" + rowId;
	membersDiv.setAttribute('rowId', rowId);
	membersDiv.className = "membersList";
	membersDiv.onclick = Roles.privileges_onClick;
	
	var anchor = document.createElement('a');
	anchor.href = "javascript: none()";
	anchor.onclick = Roles.privileges_onClick;
	anchor.setAttribute('rowId', rowId);
	var image = document.createElement('img');
	image.id = "img" + rowId;
	image.setAttribute('rowId', rowId);
	image.src = "<change:urlCreator webResource='PTIMAGES'/>listbox.gif";
	image.alt= "<change:resource key='altTextListbox'/>";
	image.title="<change:resource key='selectPrivilegeTooltip' bundle='53_patch'/>";
	anchor.appendChild(image);
	
	membersContainerDiv.appendChild(membersDiv);
	membersContainerDiv.appendChild(anchor);
	membersTD.appendChild(membersContainerDiv);
	row.appendChild(membersTD);
	
	var linksTD = document.createElement('td');
	var addLink = document.createElement('a');
	addLink.href = 'javascript: none()';
	addLink.onclick = Roles.addRow_onClick;
	addLink.appendChild(document.createTextNode('<change:resource key="lbl00333"/>')); 
	var textNode = document.createTextNode(' | ');
	var deleteLink = document.createElement('a');
	deleteLink.href = 'javascript: none()';
	deleteLink.onclick = Roles.removeRow_onClick;
	deleteLink.appendChild(document.createTextNode('<change:resource key="lbl00225"/>'))
	linksTD.appendChild(addLink);
	linksTD.appendChild(textNode);
	linksTD.appendChild(deleteLink);
	linksTD.className = 'row-widgets';
	row.appendChild(linksTD);
	
	return row;
};

Roles._addNewRow = function(position, isFirst)
{
	var tbody = dojo.byId('user-roles');
	var newRow = Roles._buildNewRow();
	
	tbody.insertBefore(newRow, tbody.rows[position] ? tbody.rows[position] : null);
	Zebra.stripeBody(tbody, 'odd-row');
	
	if (!isFirst)
	{
		StyleUtils.addClass(newRow, 'creating');
		window.setTimeout(
			function(){
				StyleUtils.removeClass(newRow, 'creating');
			},
			300);
	}
	
	var rowId = newRow.getAttribute('rowId');
	dojo.byId('name' + rowId).focus();
};

Roles.addRow_onClick = function(e)
{
	var addLink = EventUtils.getTarget(e);
	var selectedRow = getAncestorElementByTagName(addLink, 'tr');
	
	Roles._addNewRow(selectedRow.sectionRowIndex + 1, false);
	Roles.setModified(true);

	return false;
};

Roles.removeRow_onClick = function(e)
{
	var removeLink = EventUtils.getTarget(e);
	var row = getAncestorElementByTagName(removeLink, 'tr');
	
	StyleUtils.addClass(row, 'deleting');
	
	if (!confirm('<change:resource key="confirmDeleteRole"/>'))
	{
		StyleUtils.removeClass(row, 'deleting');
		return;
	}

	var userRoles = row.parentNode;
	userRoles.removeChild(row);
	
	if (userRoles.rows.length == 0)
	{
		// show the empty message  when there are no others roles.
		dojo.byId('no-roles').style.display = '';
	}
	
	var rules = dojo.byId('user-roles');
	Zebra.stripeBody(rules, 'odd-row');
	Roles.setModified(true);

	return false;
};

Roles.addFirst_onClick = function()
{
	dojo.byId('no-roles').style.display = 'none';
	Roles._addNewRow(0, true);
	Roles.setModified(true);
};

/* Methods for dealing with the popup dialog */
Roles.privileges_onClick = function(e)
{
	EventUtils.stopPropagation(e);
	var target = EventUtils.getTarget(e);
	var rowId = target.getAttribute('rowId');
	
	var privilegeListStr = dojo.byId('members' + rowId).innerHTML;
	var privilegeList = privilegeListStr.split(',');
	var numberOfCheckboxes = ${fn:length(privilegesToLifecycleMap)};
	
	for (var i = 0; i < numberOfCheckboxes; i++)
	{
		var checkbox = dijit.byId('chkbox_' + i);
		checkboxValue = checkbox.value;
		
		var found = false;
		
		for (var j = 0; j < privilegeList.length; j++)
		{
			var privilege = dojo.string.trim(privilegeList[j]);
			
			if (privilege == checkboxValue)
			{
				found = true;
				continue; 
			}
		}
		
		checkbox.setChecked(found);
	}
	
	var image = dojo.byId('img' + rowId);
	var popup = dijit.byId('privilege-selector-popup');
		
	dijit.popup.open({popup: popup, orient: {'BR': 'TR', 'BL': 'TL'}, around: image});
	dojo.byId('privilege-selector-popup').setAttribute('rowId', rowId);

	return false;
};


Roles.popupUpdate_onClick = function()
{
	var numberOfCheckboxes = ${fn:length(privilegesToLifecycleMap)};
	var privilegeList = '';
	
	for (var i = 0; i < numberOfCheckboxes; i++)
	{
		var checkbox = dijit.byId('chkbox_' + i);
		
		if (checkbox.checked)
		{
			if (privilegeList.length > 0)
			{
				privilegeList += ", ";
			}
			
			privilegeList += checkbox.value;
		}
	}
	
	var rowId = dojo.byId('privilege-selector-popup').getAttribute('rowId', rowId);
	var originalPrivList = dojo.byId('members' + rowId).innerHTML;
	dojo.byId('members' + rowId).innerHTML =  privilegeList;
	
	if (originalPrivList != privilegeList)
	{
		Roles.setModified(true);
	}
	
	Roles.closePopup();
};

Roles.closePopup = function()
{
	dijit.popup.close(dijit.byId('privilege-selector-popup'));
};

Roles.checkClosePopup = function(e)
{
	var target = EventUtils.getTarget(e);
	var popup = dojo.byId('privilege-selector-popup');
	
	var rowId1 = target.getAttribute(rowId1);
	var rowId2 = popup.getAttribute(rowId1);
	
	if (rowId1 != null && rowId2 != null)
	{
		if (rowId1 == rowId2)
		{
			return;
		}
	}
	
	while (target.parentNode)
	{
		if (target == popup)
		{
			return;
		}
		
		target = target.parentNode
	}
	
	Roles.closePopup();
};

/* Miscellaneous functions */

Roles.roleNameChanged = function(e)
{
	var input = EventUtils.getTarget(e);
	var originalValue = input.getAttribute('originalValue');
	var currentValue = input.value;
	
	if (currentValue != originalValue)
	{
		Roles.setModified(true);
	}
};

Roles.Modified = false;

Roles.setModified = function(value)
{
	Roles.Modified = value

	if (value)
	{
		dojo.byId('save-button').style.color = 'red';
	}
	else
	{
		dojo.byId('save-button').style.color = 'black';
	}

	//Set the dirty flag
	parent.parent.parent.subbuttonbar.isProjectDataModified = value;
};

// Used in the save callback to broadcast role changes to the Projects tab.
Roles.lastSavedRoles = [];

Roles.save_onClick = function()
{
	if (!Roles.Modified)
		return;

	var roles = new Array();
	var tbody = dojo.byId('user-roles');
	
	for (var i = 0; i < tbody.rows.length; i++)
	{
		var roleName = dojo.string.trim(Roles.columnValueFunctions[0](tbody.rows[i]));
		
		for (var j = 0; j < roles.length; j++)
		{
			if (roles[j].name == roleName)
			{
				var messageFormat = new MessageFormat("<change:resource key="rowXandYSameNameX"/>");
				alert(messageFormat.format([j, i, roleName]));

				var rowId = tbody.rows[i].getAttribute('rowId');
				var roleInput = dojo.byId('name' + rowId);
				roleInput.select();
				roleInput.focus();
				
				return;
			}
		}
		 
		roles[i] = new Object();
		roles[i].name = roleName; 
		
		var privilegeListStr = Roles.columnValueFunctions[1](tbody.rows[i]);
		roles[i].privileges = new Array();
		
		var privilegeList = privilegeListStr.split(',');
		
		for (var j = 0; j < privilegeList.length; j++)
		{
			var privilege = dojo.string.trim(privilegeList[j]);
			
			if (privilege.length > 0)
			{
				roles[i].privileges[j] = privilege;
			}
		}
		
		var rowId = tbody.rows[i].getAttribute('rowId');
		
		if (roles[i].name == "")
		{
			var roleInput = dojo.byId('name' + rowId);
			
			var messageFormat = new MessageFormat('<change:resource key="rowXMissingRoleName"/>');
			alert(messageFormat.format([i]));	
			roleInput.focus();
			
			return;
		}
		
		if (roles[i].privileges.length == 0)
		{
			var messageFormat = new MessageFormat('<change:resource key="roleXMissingPrivileges"/>');
			alert(messageFormat.format([roles[i].name]));

			return;
		}
	}
	
	Roles.lastSavedRoles = roles;
	ManageRolesAjax.saveRoles("${user.token}", roles, Roles.saveCallBack);
};

Roles.saveCallBack = function(result)
{
	document.messageAction.isErrorMessage.value = result.errorMessage;
	document.messageAction.message.value = result.message;
	document.messageAction.submit();
	
	if (!result.errorMessage)
	{
		Roles.setModified(false);
		
		if (Roles.lastSavedRoles && window.parent.project_view &&
				window.parent.project_view.setRoles)
		{
			window.parent.project_view.setRoles(Roles.lastSavedRoles);
		}

		if (Roles.lastSavedRoles && window.parent.global_assignments_view &&
				window.parent.global_assignments_view.updateRoles)
		{
			window.parent.global_assignments_view.updateRoles(Roles.lastSavedRoles);
		}

		//Just after successfull saving the roles, update the role count.
		Roles.syncPageWithFilteredResults();
	}
	else
	{
		if (result.message.length > 100)
		{
			alert(result.message);
		}
	}
};

Roles.init = function()
{
	dojo.connect(dojo.byId('filter-string'), 'onkeyup', function(event){Roles.filterKeyUp(event)});
	dojo.connect(document, 'onclick', function(event){Roles.checkClosePopup(event)});
	
	new TableSorter(dojo.byId('user-roles'), Roles.columnValueFunctions, 'odd-row');
	
	var myTooltip = new dijit.TooltipDialog({}, "privilege-selector-popup");
	dojo.byId("privilege-selector-popup").style.display = "none";
	
	<%-- Ensure the popup is seen. Do after delay since dojo doesnt show this right away.  --%> 
	dojo.connect(myTooltip, 'onFocus', function(pos) {
		window.setTimeout(function() {
		dojo.byId('popup-update-button').focus();
		}, 10);
		
	});
	myTooltip.startup();

	//Reset the dirty flag
	parent.parent.parent.subbuttonbar.isProjectDataModified = false;
};

function none()
{
	/*do nothing, a dummy function to avoid location change*/
}

dojo.addOnLoad(Roles.init);
	</script>
</head>

<body class="tundra">

<div id="search-box" style="text-align: right;">
	<input id="filter-string" type="text">
	<button type="button" id="filter-button" onclick="Roles.filter_onClick()" title="<change:resource key="rolesFilterTitle"/>"><change:resource key="rolesFilter"/></button>
	<button type="button" id="filter-all-button" onclick="Roles.showAll_onClick()" DISABLED="disabled"><change:resource key="rolesShowAll"/></button>
</div>

<c:set value="${fn:length(roles)}" var="numberOfRoles"/>

<div id="count-message" style="text-align: right; padding-top: .5em;">
	<c:choose>
		<c:when test="${numberOfRoles == 1}">
			<change:resource key="rolesShowingOneRole"/>
		</c:when>
		<c:otherwise>
			<change:resource key="rolesShowingXRoles">
				<change:param value="${numberOfRoles}"/>
			</change:resource>
		</c:otherwise>
	</c:choose>
</div> 


<table class="acl-table" id="role-table" cellspacing="0" style="width: 100%">

<thead>
<tr>
	<th>
		<a href="#" class="sort-header" nowrap="nowrap">
			<change:resource key='roleName'/>
		</a>
	</th>
	<th style="width: 3000px">
		<a href="#" class="sort-header">
			<change:resource key='privileges'/>
		</a>
	</th>
	<th>
		<!-- empty header for "Add | Delete" row -->
	</th>
</tr>
</thead>

<!--  if length of roles is 0 then show this, else hide it. -->
<tbody id="no-roles" class="informational" <c:if test="${numberOfRoles != 0}"> style="display: none;"</c:if>>
<tr>
	<td colspan="2">
		<change:resource key='rolesBlankRole'/>
	</td>
	<td class="row-widgets">
		<a href="#" onclick="Roles.addFirst_onClick()">
			<change:resource key='lbl00333'/>
		</a>
	</td>
</tr>
</tbody>

<tbody id="user-roles">
<c:forEach items="${roles}" var="role" varStatus="status">
	<tr rowId="${status.index}" <c:if test="${status.index % 2 == 1}">class="odd-row"</c:if>>
		<td>
			<input id="name${status.index}" size="30" rowId="${status.index}" value="${role.name}" originalValue="${role.name}" onblur="Roles.roleNameChanged(event)">
		</td>
		<td>
			<c:set value="${fn:length(role.privileges)}" var="numberOfPrivileges"/>
			<c:set value="" var="privilegeString" />
			<c:forEach items="${role.privileges}" var="privilege" varStatus="privStatus">
				<c:choose>
					<c:when test="${privStatus.index == 0}">
						<c:set value="${privilege}" var="privilegeString" />
					</c:when>
					<c:otherwise>
						<c:set value="${privilegeString}, ${privilege}" var="privilegeString" />
					</c:otherwise>
				</c:choose>
			</c:forEach>
			<div>
				<div id="members${status.index}" rowId="${status.index}" class="membersList" onclick="Roles.privileges_onClick(event)">${privilegeString}</div>
				<a href="javascript: none()" onclick="Roles.privileges_onClick(event)" rowId="${status.index}"><img  title="<change:resource key='selectPrivilegeTooltip' bundle='53_patch'/>" alt="<change:resource key='altTextListbox'/>" src="<change:urlCreator webResource='PTIMAGES'/>listbox.gif" id="img${status.index}" rowId="${status.index}"></a>
			</div>
		</td>
		<td class="row-widgets">
			<a href="javascript: none()" onclick="Roles.addRow_onClick(event)"><change:resource key="lbl00333"/></a>
			&nbsp;|&nbsp;
			<a href="javascript: none()" onclick="Roles.removeRow_onClick(event)"><change:resource key="lbl00225"/></a>
		</td>
	</tr>
</c:forEach>
</tbody>

</table>

<div id="privilege-selector-popup" style="display: none; ">
	<table class="barHeading" width="200px">
		<tr>
			<th id="header"> 
				<change:resource key='selectPrivileges'/>
			</th>
		</tr>
	</table>
		
	<div style="width: 200px; max-width: 200px;">
		<div id="checkboxes" style="border: 1px solid gray; padding: 5px; height: 200px; overflow:auto;">
			<table cellpadding="0" cellspacing="0">
			<c:forEach items="${privilegesToLifecycleMap}" var="mapEntry" varStatus="status">
			<tr>
				<td nowrap="nowrap" style="padding: 2px;" id="chkboxrow_${status.index}"
					lifecycles="<c:forEach items="${mapEntry.value}" var="lifecycle">%${lifecycle}%</c:forEach>">
				
					<input type="checkbox" dojotype="dijit.form.CheckBox" id="chkbox_${status.index}" value="${mapEntry.key}">
					<label for="chkbox_${status.index}">${mapEntry.key}</label>
				</td>
			</tr>
			</c:forEach>
			</table>
		</div>
	</div>
	
	<div style="text-align: center; margin-top: 5px;">
		<button id="popup-update-button" type="button" onclick="Roles.popupUpdate_onClick()"><change:resource key='lbl00242'/></button>
	</div>
</div>

<br />
<div style="text-align: center;">
	<button onclick="Roles.save_onClick()" id="save-button"><change:resource key='lbl00592'/></button>
</div>

<form name="messageAction" target="pt_status" method="POST" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do">
	<input name="token" type="hidden" value="${user.token}">
	<input name="formName" type="hidden" value="statusLineMessage">
	<input name="isErrorMessage" type="hidden">
	<input name="message" type="hidden">
</form>

</body>

</html>
