<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_framework\home_page_nav.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=styles/default.css -->
			<!-- PARAM NAME=styles/homepage_nav.css -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		body
		{
			background: #637999;
		}
	</style>
	
	<script type="text/javascript" src="dwr/interface/LdapUserUtilsAjax.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>

	<script type="text/javascript">	 	
		dojo.require("dijit.TitlePane");
		dojo.require("dojo.fx");
	</script>	
	
	<script type="text/javascript">
		//Global variable for tracking the last highlighted id
		var previousId;
		
		//Global array variable of current home page names.
		var homePages = new Array();
		<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
			homePages[${status.index}] = <change:javaScriptEscape value="${homePage.name}"/>;
		</c:forEach>
		
		var adminHomePages = new Array();
		<c:forEach items="${adminHomePages.homePages}" var="adminHomePage" varStatus="status">
			adminHomePages[${status.index}] = <change:javaScriptEscape value="${adminHomePage.name}"/>;
		</c:forEach>
		
		<change:wsletExpander>
			<!-- WSLET CODE=PTInclude -->
			<!-- PARAM NAME=domUtilities.js -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		<change:wsletExpander>
			<!-- WSLET CODE=WsletUpdate -->
			<!-- PARAM NAME=TDS_DOWN -->
			<!-- /WSLET -->
		</change:wsletExpander>
		
		function hasModifications()
		{
			if (parent.homepage.hasModifications)
			{
				return parent.homepage.hasModifications();
			}
			
			if (parent.homepage.showView && parent.homepage.showView.workspace 
				&& parent.homepage.showView.workspace.hasModifications)
			{
				return parent.homepage.showView.workspace.hasModifications();
			}
			
			return false;
		}
		
		function modifyTitlePane()
		{	
			if (tds_down)
			{
				alert("<change:resource key='authServerUnavailable'/>");
				return;
			}
		
			var divs = getElementsByClassName(null, "dijitTitlePaneTextNode");
		
			for (var x = 0; x < divs.length; x++)
			{
				dojo.connect(divs[x], 'onmouseover', null, function(e)
				{
					e.target.style.textDecoration = "underline";
				});
				dojo.connect(divs[x], 'onmouseout', null, function(e)
				{
					e.target.style.textDecoration = "none";
				});
					
				//give each of the labels a tab index so the keyboard will stop on it.
				divs[x].tabIndex = 1;
				
				<%-- Kind of a hack to add an onclick event to the dojo TitlePane widget --%>	
				if (divs[x].innerHTML == "<change:resource key='homePages'/>")
				{	
					<c:if test="${empty homePages.homePages}">
						dojo.connect(divs[x], "onclick", null, 
							function(){loadHelpTemplate("homePageHelp");});
					</c:if>
				}
				else if (divs[x].innerHTML == "<change:resource key='browse'/>")
				{
					<c:if test="${empty browsableQueries}">
						dojo.connect(divs[x], "onclick", null,  
							function() {loadHelpTemplate("browseHelp");});
					</c:if>
				}
				else if (divs[x].innerHTML == "<change:resource key='defaultHomePages'/>")
				{
					<c:if test="${empty adminHomePages.homePages}">
						dojo.connect(divs[x], "onclick", null,  
							function() {loadHelpTemplate("adminHomePageHelp");});
					</c:if>
				}
				else if (divs[x].innerHTML == "<change:resource key='defaultBrowse'/>")
				{
					<c:if test="${empty adminBrowsableQueries}">
						dojo.connect(divs[x], "onclick", null,  
							function() {loadHelpTemplate("adminBrowseHelp");});
					</c:if>
				}
			}			
		}
		
		//extend dijit.TitlePane's postCreate method to add the feature of saving user preference.
		dojo.extend(dijit.TitlePane,
		{
			postCreate: function(){
				this.setTitle(this.title);
				if(!this.open){
					this.hideNode.style.display = this.wipeNode.style.display = "none";
				}
				this._setCss();
				dojo.setSelectable(this.titleNode, false);
				dijit.TitlePane.superclass.postCreate.apply(this, arguments);
				//this.inherited(arguments);
				dijit.setWaiState(this.containerNode, "labelledby", this.titleNode.id);
				dijit.setWaiState(this.focusNode, "haspopup", "true");
		
				// setup open/close animations
				var hideNode = this.hideNode, wipeNode = this.wipeNode;
				this._wipeIn = dojo.fx.wipeIn({
					node: this.wipeNode,
					duration: this.duration,
					beforeBegin: function(){
						hideNode.style.display="";						
					},
					onEnd: function(){
						findClosedSections();
					}
				});
				this._wipeOut = dojo.fx.wipeOut({
					node: this.wipeNode,
					duration: this.duration,
					onEnd: function(){
						hideNode.style.display="none";
						findClosedSections();
					}
				});
			}
		});
		
		//find the closed TitlePanes and store its state as a user preference.
		function findClosedSections()
		{
			var closedPanels = new Array();			
 			
 			dijit.registry.forEach(function(widget)
 			{
 				if (widget.declaredClass="dijit.TitlePane" && !widget.open)
				{	
					closedPanels[closedPanels.length] = widget.id;
				}
 			});
			
			LdapUserUtilsAjax.setStringPreference("${user.token}", 'user_closed_home_page_sections', closedPanels.toString());
		}
		
		function keyUpDetection(evt)
		{
			//fix the event so target works, stupid browsers.
			evt = dojo.fixEvent(evt);
			
			if (evt.keyCode == 13)
			{
				//user hit enter.
				evt.target.onclick();
			}
		}
		
		function loadSplash()
		{
			var splashLocation = "<change:urlCreator webResource='PTIMAGES'/>splashChangeSynergy.png";
			
			var noneHtml = "<TABLE WIDTH='100%' HEIGHT='90%' BORDER=0><TR><TD ALIGN=center VALIGN=center><IMG SRC='" + splashLocation + "' ALT='<change:resource key="lbl00010"/>'></TD></TR></TABLE>";
			
			parent.homepage.document.write(noneHtml);
			parent.homepage.document.close();
		}
		
		function loadHelpTemplate(templateName)
		{
			//clear the current id.
			if ((previousId != null) && (previousId.length != 0))
			{
				document.getElementById(previousId).style.background = "";
			}
			
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
			
			loadWorkspaceTemplate(templateName);
		}
		
		function loadWorkspaceTemplate(templateName)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			window.document.formLoad.method              = "POST";
			window.document.formLoad.action              = "<change:urlCreator webResource='PTWEB'/>";
			window.document.formLoad.target              = "homepage";
			window.document.formLoad.ACTION_FLAG.value   = "workspace_form";
			window.document.formLoad.TEMPLATE_FLAG.value = templateName;
			window.document.formLoad.role.value          = "${user.role}";
			window.document.formLoad.token.value         = "${user.token}";
		
			window.document.formLoad.submit();
		}
		
		function addHomePageOnClick(asAdmin)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			window.document.createHomePage.actionFlag.value = "pageLayout";
			window.document.createHomePage.asAdmin.value    = asAdmin;
		
			window.document.createHomePage.submit();
		}
		
		function manageBrowsableQueriesOnClick(asAdmin)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			window.document.manageBrowsableQueries.asAdmin.value    = asAdmin;
			window.document.manageBrowsableQueries.submit();
		}
		
		function setDefaultHomePageOnClick()
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			<c:if test="${empty homePages.homePages}">
				loadHelpTemplate("homePageHelp");
				return;
			</c:if>
		
			window.document.setDefaultHomePage.submit();
		}
		
		function assignDefaultHomePagesOnClick()
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			<c:if test="${empty adminHomePages.homePages}">
				loadHelpTemplate("adminHomePageHelp");
				return;
			</c:if>
			
			window.document.assignDefaulthomePages.submit();
		}
		
		function assignDefaultBrowseOnClick()
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			<c:if test="${empty adminBrowsableQueries}">
				loadHelpTemplate("adminBrowseHelp");
				return;
			</c:if>
		
			window.document.assignDefaultBrowse.submit();
		}
		
		function highlight(id)
		{
			document.getElementById(id).style.background = "#f78100";
			
			if ((previousId != null) && (previousId.length != 0) && (previousId != id))
			{
				document.getElementById(previousId).style.background = "";
			}
			
			previousId = id;
		}
		
		function displayHomePage(homePage, adminDefined, asAdmin)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			window.document.loadHomePage.homePageName.value   = homePage;
			window.document.loadHomePage.isAdminDefined.value = adminDefined;
			window.document.loadHomePage.asAdmin.value        = asAdmin;
		
			window.document.loadHomePage.submit();
		}
		
		function displayBrowsableQuery(browsableQuery, adminDefined, asAdmin)
		{
			if (hasModifications())
				if (!confirm("<change:resource key='err00074'/>"))
					return false;
					
			window.document.loadBrowsableFrameset.browsableQueryName.value = browsableQuery;
			window.document.loadBrowsableFrameset.isAdminDefined.value     = adminDefined;
			window.document.loadBrowsableFrameset.asAdmin.value            = asAdmin;
		
			window.document.loadBrowsableFrameset.submit();
		}
		
		function displayMyHomePage(homePageIndex)
		{
			displayHomePage(homePages[homePageIndex]);
		}
		
		dojo.addOnLoad(modifyTitlePane);
		
		<c:if test="${codeReload == false}">
			<%-- only load a default if it was a user reload and not a code reload --%>
			<c:choose>
				<c:when test="${empty homePages.defaultHomePage}">
				<c:choose>
						<c:when test="${empty homePages.adminDefaultHomePage}">
							dojo.addOnLoad(loadSplash);
						</c:when>
						<c:otherwise>
							<c:set value="${homePages.adminDefaultHomePage}" var="adminHomePage" />
							dojo.addOnLoad(function()
								{
									<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
										<c:if test="${fn:escapeXml(adminHomePage) == fn:escapeXml(homePage.name)}">
											displayMyHomePage( "${status.index}" );
											highlight("homePage_" + "${status.index}");
										</c:if>
									</c:forEach>
								}
							);
						</c:otherwise>
					</c:choose>
				</c:when>
				<c:otherwise>
					dojo.addOnLoad(function()
						{
							<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
								<c:if test="${fn:escapeXml(homePages.defaultHomePage) == fn:escapeXml(homePage.name)}">
									displayMyHomePage( "${status.index}" );
									highlight("homePage_" + "${status.index}");
								</c:if>
							</c:forEach>
						}
					);
				</c:otherwise>
			</c:choose>
		</c:if>
	</script>
</head>

<body>
	<div style="width: 100%; height: 1px; background: #637999;">
	</div>
	<div dojoType="dijit.TitlePane" title="<change:resource key='homePages'/>" id="homePages" class="label" 
		open="<c:choose><c:when test="${fn:contains(closedPanels, 'homePages')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
		<!-- In case the div is empty this will make it work right on IE. -->
		<table class="content" cellspacing="0" cellpadding="0">		
			<c:forEach items="${homePages.homePages}" var="homePage" varStatus="status">
				<tr>
					<td id="homePage_${status.index}" class="highlight"></td>
					<td class="item">
						<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:displayHomePage(<change:javaScriptEscape value="${homePage.name}"/>, ${homePage.adminDefined}, false); highlight('homePage_${status.index}');"
							onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
								<c:out value="${homePage.name}"/>
								<c:choose>
									<c:when test="${(empty homePages.defaultHomePage)}">
										<c:choose>
											<c:when test="${!(empty homePages.adminDefaultHomePage) && (homePages.adminDefaultHomePage == homePage.name)}">
												*
											</c:when>
										</c:choose>
									</c:when>
									<c:otherwise>
										<c:choose>
											<c:when test="${(homePages.defaultHomePage == homePage.name)}">
												*
											</c:when>
										</c:choose>
									</c:otherwise>
								</c:choose>
						</span>
					</td>
				</tr>
			</c:forEach>
		</table>
	</div>
	
	<div dojoType="dijit.TitlePane" title="<change:resource key='browse'/>" id="browse" class="label"
		open="<c:choose><c:when test="${fn:contains(closedPanels, 'browse')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
		<!-- In case the div is empty this will make it work right on IE. -->		
		<table class="content" cellspacing="0" cellpadding="0">
			<c:forEach items="${browsableQueries}" var="browsableQuery" varStatus="status">
				<tr>
					<td id="browsableQuery_${status.index}" class="highlight"></td>
					<td class="item">
						<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:displayBrowsableQuery(<change:javaScriptEscape value="${browsableQuery.name}"/>, '${browsableQuery.adminDefined}', false); highlight('browsableQuery_${status.index}');"
							onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
							<c:out value="${browsableQuery.name}"/>
						</span>
					</td>
				</tr>
			</c:forEach>
		</table>
	</div>
	
	<div dojoType="dijit.TitlePane" title="<change:resource key='configure'/>" id="configure" class="label"
		open="<c:choose><c:when test="${fn:contains(closedPanels, 'configure')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
		<table class="content" cellspacing="0" cellpadding="0">
		<tr>
			<td id="addHomePageHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:addHomePageOnClick(false); highlight('addHomePageHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="addHomePage"/>
				</span>
			</td>
		</tr>
		<tr>
			<td id="manageQueriesHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:manageBrowsableQueriesOnClick(false); highlight('manageQueriesHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="manageBrowsableQueries"/>
				</span>
			</td>
		</tr>
		<tr>
			<td id="setDefaultHomePageHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:setDefaultHomePageOnClick(); highlight('setDefaultHomePageHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="setDefaultHomePage"/>
				</span>
			</td>
		</tr>
		</table>
	</div>
	
	<c:if test="${isAdmin == true}">	
		<div dojoType="dijit.TitlePane" title="<change:resource key='lbl01087'/>" id="administration" class="label"
			open="<c:choose><c:when test="${fn:contains(closedPanels, 'administration')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
			<table class="content" cellspacing="0" cellpadding="0">
		<tr>
			<td id="createDefaultHomePageHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:addHomePageOnClick(true); highlight('createDefaultHomePageHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="createDefaultHomePage"/>
				</span>
			</td>
		</tr>
		<tr>
			<td id="createDefaultBrowseHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:manageBrowsableQueriesOnClick(true); highlight('createDefaultBrowseHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="createDefaultBrowse"/>
				</span>
			</td>
		</tr>
		<tr>
			<td id="assignDefaultHomePagesHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:assignDefaultHomePagesOnClick(); highlight('assignDefaultHomePagesHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="assignDefaultHomePages"/>
				</span>
			</td>
		</tr>
		<tr>
			<td id="assignDefaultBrowseHL" class="highlight"></td>
			<td class="item">
				<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:assignDefaultBrowseOnClick(); highlight('assignDefaultBrowseHL');"
					onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
						<change:resource key="assignDefaultBrowse"/>
				</span>
			</td>
		</tr>
		</table>
		</div>
	
		<div dojoType="dijit.TitlePane" title="<change:resource key='defaultHomePages'/>" id="defaultHomePages" class="label"
			open="<c:choose><c:when test="${fn:contains(closedPanels, 'defaultHomePages')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
			<!-- In case the div is empty this will make it work right on IE. -->
			<table class="content" cellspacing="0" cellpadding="0">		
			<c:forEach items="${adminHomePages.homePages}" var="adminHomePage" varStatus="status">
				<tr>
					<td id="adminHomePage_${status.index}" class="highlight"></td>
					<td class="item">
						<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:displayHomePage(<change:javaScriptEscape value="${adminHomePage.name}"/>, ${adminHomePage.adminDefined}, true); highlight('adminHomePage_${status.index}');"
							onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
								<c:out value="${adminHomePage.name}"/>
						</span>
					</td>
				</tr>
			</c:forEach>
		</table>
		</div>
	
		<div dojoType="dijit.TitlePane" title="<change:resource key='defaultBrowse'/>" id="defaultBrowse" class="label"
			open="<c:choose><c:when test="${fn:contains(closedPanels, 'defaultBrowse')}">false</c:when><c:otherwise>true</c:otherwise></c:choose>">
			<!-- In case the div is empty this will make it work right on IE. -->			
			<table class="content" cellspacing="0" cellpadding="0">
			<c:forEach items="${adminBrowsableQueries}" var="adminBrowsableQuery" varStatus="status">
				<tr>
					<td id="adminBrowsableQuery_${status.index}" class="highlight"></td>
					<td class="item">
						<span tabindex="1" onkeyup="javascript:keyUpDetection(event);" class="fakeLink" onclick="javascript:displayBrowsableQuery(<change:javaScriptEscape value="${adminBrowsableQuery.name}"/>, '${adminBrowsableQuery.adminDefined}', true); highlight('adminBrowsableQuery_${status.index}');"
							onMouseOver="this.style.textDecoration = 'underline'" onMouseOut="this.style.textDecoration = 'none'">
							<c:out value="${adminBrowsableQuery.name}"/>
						</span>
					</td>
				</tr>
			</c:forEach>
		</table>
		</div>
	
	</c:if>
	
	<form name="formLoad" action="NO_ACTION" class="hiddenForm">
		<input name="ACTION_FLAG"   type="hidden" value="NO_ACTION">
		<input name="TEMPLATE_FLAG" type="hidden" value="NO_ACTION">
		<input name="role"          type="hidden" value="NO_ACTION">
		<input name="token"         type="hidden" value="NO_ACTION">
	</form>
	
	<form name="createHomePage" action="<change:urlCreator webResource='BASEURL'/>/createHomePage.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
		<input name="actionFlag" type="hidden">
		<input name="asAdmin" type="hidden">
		<input name="editMode" type="hidden" value="false">
	</form>
	
	<form name="manageBrowsableQueries" action="<change:urlCreator webResource="BASEURL"/>/manageBrowsableQueries.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
		<input name="actionFlag" type="hidden" value="manageQueries">
		<input name="asAdmin" type="hidden">
	</form>
	
	<form name="loadHomePage" action="<change:urlCreator webResource='BASEURL'/>/loadHomePage.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
		<input name="homePageName" type="hidden">
		<input name="isAdminDefined" type="hidden">
		<input name="asAdmin" type="hidden">
	</form>
	
	<form name="setDefaultHomePage" action="<change:urlCreator webResource='BASEURL'/>/showDefaultHomePages.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
	</form>
	
	<form name="assignDefaulthomePages" action="<change:urlCreator webResource='BASEURL'/>/assignDefaultHomePages.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
	</form>
	
	<form name="assignDefaultBrowse" action="<change:urlCreator webResource='BASEURL'/>/assignDefaultBrowsableQueries.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
	</form>
	
	<form name="loadBrowsableFrameset" action="<change:urlCreator webResource='BASEURL'/>/framesetLoader.do" class="hiddenForm" method="POST" target="homepage">
		<input name="token" type="hidden" value="${user.token}">
		<input name="frameName" type="hidden" value="browse">
		<input name="browsableQueryName" type="hidden">
		<input name="isAdminDefined" type="hidden">
		<input name="asAdmin" type="hidden">
	</form>
</body>
</html>
